Gecode::Support::BitSet< A > Class Template Reference

Simple bitsets. More...

`#include <bitset.hpp>`

## Public Member Functions

| BitSet (A &a, unsigned int s, bool set=false)
| Bit set with space for s bits.
| BitSet (A &a, const BitSet &bs)
| Copy bit set bs.
| ~BitSet (void)
| Destructor.
Public Member Functions inherited from Gecode::Support::BitSetBase
| BitSetBase (void)
| Default constructor (yields empty set).
template<class A>
| BitSetBase (A &a, unsigned int s, bool setbits=false)
| Initialize for s bits and allocator a.
template<class A>
| BitSetBase (A &a, const BitSetBase &bs)
| Copy from bitset bs with allocator a.
template<class A>
void | init (A &a, unsigned int s, bool setbits=false)
| Initialize for s bits and allocator a (only after default constructor).
void | clearall (bool setbits=false)
| Clear sz bits.
void | copy (const BitSetBase &bs)
| Copy sz bits from bs.
unsigned int | size (void) const
| Return size of bitset (number of bits).
bool | get (unsigned int i) const
| Access value at bit i.
void | set (unsigned int i)
| Set bit i.
void | clear (unsigned int i)
| Clear bit i.
unsigned int | next (unsigned int i) const
| Return position greater or equal i of next set bit (i is allowed to be equal to size).
BitSetStatus | status (void) const
| Return status of bitset.
bool | all (void) const
| Test whether all bits are set.
bool | none (void) const
| Test whether no bits are set.
template<class A>
void | resize (A &a, unsigned int n, bool setbits=false)
| Resize bitset to n elememts.
template<class A>
void | dispose (A &a)
| Dispose memory for bit set.
Public Member Functions inherited from Gecode::Support::RawBitSetBase
| RawBitSetBase (void)
| Default constructor (yields empty set).
template<class A>
| RawBitSetBase (A &a, unsigned int sz, bool setbits=false)
| Initialize for sz bits and allocator a.
template<class A>
| RawBitSetBase (A &a, unsigned int sz, const RawBitSetBase &bs)
| Copy from bitset bs with allocator a.
template<class A>
void | allocate (A &a, unsigned int sz)
| Allocate for sz bits and allocator a (only after default constructor).
template<class A>
void | init (A &a, unsigned int sz, bool setbits=false)
| Initialize for sz bits and allocator a (only after default constructor).
void | clearall (unsigned int sz, bool setbits=false)
| Clear sz bits.
void | copy (unsigned int sz, const RawBitSetBase &bs)
| Copy sz bits from bs.
bool | get (unsigned int i) const
| Access value at bit i.
void | set (unsigned int i)
| Set bit i.
void | clear (unsigned int i)
| Clear bit i.
unsigned int | next (unsigned int i) const
| Return position greater or equal i of next set bit (i is allowed to be equal to size).
BitSetStatus | status (unsigned int sz) const
| Return status of bitset.
bool | all (unsigned int sz) const
| Test whether all bits are set.
bool | none (unsigned int sz) const
| Test whether no bits are set.
template<class A>
void | resize (A &a, unsigned int sz, unsigned int n, bool setbits=false)
| Resize bitset from sz to n elememts.
template<class A>
void | dispose (A &a, unsigned int sz)
| Dispose memory for bit set.

## Protected Attributes

A & | a
| Allocator.
Protected Attributes inherited from Gecode::Support::BitSetBase
unsigned int | sz
| Size of bitset (number of bits).
Protected Attributes inherited from Gecode::Support::RawBitSetBase
BitSetData * | data
| Stored bits.

## Additional Inherited Members

Static Protected Attributes inherited from Gecode::Support::RawBitSetBase
static const unsigned int | bpb = BitSetData::bpb
| Bits per base.

## Detailed Description

template<class A>
class Gecode::Support::BitSet< A >

Simple bitsets.

Definition at line 45 of file bitset.hpp.

## Constructor & Destructor Documentation

## BitSet() [1/2]

template<class A>

Gecode::Support::BitSet< A >::BitSet | ( | A & | a,
|  | unsigned int | s,
|  | bool | set = false )

inline

Bit set with space for s bits.

Definition at line 60 of file bitset.hpp.

## BitSet() [2/2]

template<class A>

Gecode::Support::BitSet< A >::BitSet | ( | A & | a,
|  | const BitSet< A > & | bs )

inline

Copy bit set bs.

Definition at line 65 of file bitset.hpp.

## ~BitSet()

template<class A>

Gecode::Support::BitSet< A >::~BitSet | ( | void |  | ) |

inline

Destructor.

Definition at line 70 of file bitset.hpp.

## Member Data Documentation

## a

template<class A>

A& Gecode::Support::BitSet< A >::a

protected

Allocator.

Definition at line 48 of file bitset.hpp.

The documentation for this class was generated from the following file:

- gecode/support/bitset.hpp